/* ****************************************************************************
 * 1 Document 2 Rule them All 3
 * Last Update: 15 February 2019
 * http://TrinaryUniversity.org/books/1-document-2-rule-them-all-3/book/oebps/
 * 1-document-2-rule-them-all-3-kindle-ebook-pdf-web-page.html
 * Copyright and Copyleft by Jeffrey Scott Flesher
 *
 * Below is for JSlint http://jslint.com/;
 * do not alter it, no space before global.
 */
/*global window */
/* ****************************************************************************
 *  number With Commas
 *  123,456 returns numberWithCommas(123456)
 */
function numberWithCommas(x) {
    "use strict";
    return x.toString().replace(/\B(?=(\d{3})+(?!\d))/g, ",");
}
/* ****************************************************************************
 *  go Back: this is to return from a Link
 */
function goBack() {
    "use strict";
    window.history.back();
}
/* ****************************************************************************
 *  targetBlank
 * XHTML does not allow a target in anchor tags:
 * <a class="blank_target_link" href="X.html#X" target= "_blank">X</a>,
 * this will add a blank target to every <a with class="blank_target_link"
 */
function targetBlank() {
    "use strict";
    var myElements = document.querySelectorAll(".blank_target_link,.https_blank_target_link,.button_blank_target_link");
    [].forEach.call(myElements, function (myElement) {
        myElement.target = "_blank";
    });
}
/* ****************************************************************************
 *  Add Attribute to tage
 */
function AddAttribute(id, a, v) {
    "use strict";
    var x = document.getElementById(id);
    x.setAttribute(a, v);
}
/* ****************************************************************************
 *  Set Agent to display hidden tags
 *  ePub: Mozilla/5.0 (X11; Linux x86_64) AppleWebKit/538.1 (KHTML, like Gecko) calibre/2.85.1 Safari/538.1
 */
function setAgent() {
    "use strict";
    var str = navigator.userAgent;
    // var myLen; var i;
    var myElements;
    var debugInfo = 0; // Set to 1 to print debug_info at bottom of page
    myElements = document.querySelectorAll(".js_only");
    [].forEach.call(myElements, function (myElement) {
        myElement.style.display = "block";
    });
    // Note: Replace the word "replace_With_Book_Agent" with the userAgent used to make this into a Book
    if (str.indexOf("wkhtmltopdf") === -1 && str.indexOf("replace_With_Book_Agent") === -1) {
        // If not PDF and not replace_With_Book_Agent
        if (debugInfo === 1) {
            document.getElementById("debug_info").innerHTML = "Debug Message: " + str;
        }
        myElements = document.querySelectorAll(".a_line_show_break_html");
        [].forEach.call(myElements, function (myElement) {
            myElement.style.display = "block";
        });
        // Show in: HTML
        myElements = document.querySelectorAll(".noprint");
        [].forEach.call(myElements, function (myElement) {
            myElement.style.display = "block";
            myElement.className = "the_chapter";
        });
        // Show in: HTML and PDF
        myElements = document.querySelectorAll(".no_show_book");
        [].forEach.call(myElements, function (myElement) {
            myElement.style.display = "block";
            myElement.className = "the_chapter";
        });
        // Show in: HTML if js_only and Not PDF or Book
        myElements = document.querySelectorAll(".show_if_js_only_no_show_pdf_book");
        [].forEach.call(myElements, function (myElement) {
            myElement.style.display = "block";
        });
        // Show in Web Page Only
        myElements = document.querySelectorAll(".show_web_page_only");
        [].forEach.call(myElements, function (myElement) {
            myElement.style.display = "block";
        });
        // Show in Web Page Only
        myElements = document.querySelectorAll(".goog-te-gadget-simple");
        [].forEach.call(myElements, function (myElement) {
            myElement.style.marginTop = "0";
            myElement.style.paddingTop = "0";
            myElement.style.fontSize = "large";
        });
        // targetBlank(); // Fix in bash by renaming
    } else if (str.indexOf("wkhtmltopdf") > -1) {
        // ******************************************* Run if PDF
        if (debugInfo === 1) {
            document.getElementById("debug_info").innerHTML = "wkhtmltopdf: " + str;
        }
        // if PDF
        // Show in: HTML and PDF
        myElements = document.querySelectorAll(".no_show_book");
        [].forEach.call(myElements, function (myElement) {
            myElement.style.display = "block";
        });
        // Show in: HTML
        myElements = document.querySelectorAll(".no_show_pdf");
        [].forEach.call(myElements, function (myElement) {
            myElement.style.display = "none";
        });
        // Show in Web Page Only
        myElements = document.querySelectorAll(".show_only_pdfs");
        [].forEach.call(myElements, function (myElement) {
            myElement.style.display = "block";
        });
        // targetBlank(); // Fix in bash by renaming
    } else if (str.indexOf("replace_With_Book_Agent") > -1) {
        if (debugInfo === 1) {
            document.getElementById("debug_info").innerHTML = "replace_With_Book_Agent: " + str;
        }
        // if agent is for a Book to be printed
        // Show in: HTML if js_only and PDF and Book
    }
}
// OnLoad
document.onload = setAgent();
/* ******************* End of File ***************************************** */
